module.exports = {
    
    
    inputKeys: [],
    
    attributes: {
        
    },
    
    processAsset: function(document, rbnode, asset) {
        
        
        var theFileName = asset.outputFileName().stringByDeletingPathExtension() + ""; // Convert it to a JS string.
        
        
        // Assumes dates are year 1500 thru 2400
        // Matches first date found in the form of 2014-09-04 or 20140904; leading zeros required.
        const ISODateRegex = /(?:1[5-9]|2[0-4])\d{2}-?[01]\d-?[0-3]\d/;
        var theDate = theFileName.match(ISODateRegex);
        console.log("reg theDate: " + theDate);
        
        
        // This is not very fuzzy. File names in the format 'YYYY-MM-dd text here.jpeg'
        var theDate = theFileName.split(" ")[0];
        
        // console.log(theFileName + " theDate " + theDate)
        
        var formatter = NSDateFormatter.alloc().init();
        formatter.setDateFormat("YYYY-MM-dd")
        
        var dateObject = formatter.dateFromString(theDate);
        // console.log(dateObject)
        if (dateObject) {
            console.log("setting date on " + theFileName + " to " + dateObject)
            
            var exifStringFormat = "yyyy:MM:dd HH:mm:ss";
            
            var exifFormatter = NSDateFormatter.alloc().init();
            exifFormatter.setDateFormat(exifStringFormat)
            
            var exifStringDate = exifFormatter.stringFromDate(dateObject)
            
            asset.setImageMetaDataValue_forKey_inDictionary(exifStringDate, kCGImagePropertyIPTCDateCreated, kCGImagePropertyIPTCDictionary);
            asset.setImageMetaDataValue_forKey_inDictionary(exifStringDate, kCGImagePropertyIPTCTimeCreated, kCGImagePropertyIPTCDictionary);
            asset.setImageMetaDataValue_forKey_inDictionary(exifStringDate, kCGImagePropertyTIFFDateTime,    kCGImagePropertyTIFFDictionary);
            asset.setImageMetaDataValue_forKey_inDictionary(exifStringDate, kCGImagePropertyExifDateTimeDigitized,    kCGImagePropertyExifDictionary);
            asset.setImageMetaDataValue_forKey_inDictionary(exifStringDate, kCGImagePropertyExifDateTimeOriginal,    kCGImagePropertyExifDictionary);
        }
        else {
            console.log("Could not parse date from " + theDate + " / " + theFileName);
            console.log(theFileName.split(" "));
        }
        
        return true;
    },
    
};



